#!/boot/common/bin/python
#
# Copyright (c) 2009
#	Leszek Lesner.  All rights reserved. Released under the BSD License.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#	This product includes software developed by Leszek Lesner.
# 4. Neither the name of the Author
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#/

import commands
import os,sys,string
import re

def pkill():
    if len(sys.argv) <= 1:
        print "usage: " + sys.argv[0] + " process_name"
        sys.exit(1)
    rip = sys.argv[1]
    me = commands.getoutput("whoami")
    p = commands.getoutput("ps")
    # DEBUG print p
    ids = p.split("\n")
    for id in ids:
        if id.find(rip) < 0:
            continue
        regex = re.compile(r'(\d+).*',re.I)
        id = regex.sub(r'\1', id)
        print "killing: %s\n" % id
        commands.getoutput("kill -15 %s" % id)
        if commands.getoutput("ps").find(id) > -1:
            print "try killing hardly: %s\n" % id
            commands.getoutput("kill -9 %s" % id)
if __name__ == '__main__' :
    pkill()
